local shadscore = (...)

local backdrop = {
		bgFile = "Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga",
		edgeFile = "Interface\\AddOns\\ShadsCore\\Media\\Textures\\Caith.tga",
		edgeSize = 16,
		insets = {
			left = 2,
			right = 2,
			top = 2,
			bottom = 2
		}
	}
local font = "Interface\\AddOns\\ShadsCore\\Media\\Fonts\\font.ttf"

-- default values
local bbwidth = 740
local btwidth = 0
local healerui = true

-- function to save variables
local function shads_savevars()
	shadsvar = {}
	shadsvar["bbwidth"] = bbwidth
	shadsvar["btwidth"] = btwidth
	shadsvar["healerui"]  = healerui
end

-- localise bars so i can use them later
 local bar1
 local bar2
  
-- Create frame function
local function makeFrame(name, anchor, anX, anY, bdrop, sizeX, sizeY, bR, bG, bB, strata)
	name:SetPoint(anchor, anX, anY)
	name:SetSize(sizeX, sizeY)
	name:SetBackdrop(bdrop)
	name:SetBackdropColor(bR, bG, bB, 1)
	name:SetFrameStrata(strata)
end

-- Create font string function
local function makeFont(name, point, x, y, width, height, fontsize, text)
 name:SetPoint(point, x, y)
 name:SetSize(width, height)
 name:SetFont(font, fontsize)
 name:SetText(text)
 end
 
 -- Spawn frame function so I can run this when saved variables are loaded, meaning the bartender bars will be sized to the saved setting
local function spawnframes()
 		bar1 = CreateFrame("frame", nil, UIParent)
		makeFrame(bar1, "BOTTOM", 0, 48, backdrop, btwidth, 40, .2, .2, .2, "BACKGROUND")
		bar2 = CreateFrame("frame", nil, UIParent)
		makeFrame(bar2, "BOTTOM", 0, 3, backdrop, bbwidth, 40, .2, .2, .2, "BACKGROUND")	
		bar2:SetFrameLevel(2)
	end
 
 -- Refreshes bars so they change when enter is hit in the editbox
local function refreshbars()
	bar1:SetWidth(btwidth)
	bar1:Hide()
	bar1:Show()
	bar2:SetWidth(bbwidth)
	bar2:Hide()
	bar2:Show()
end

-- Default values
local function shads_default()
	bbwidth = 740
	btwidth = 0
	opt1:SetText(btwidth)
	opt2:SetText(bbwidth)
	refreshbars()
	shads_savevars()
	print("|cff5CBBFF ShadowmageUI|r Restoring default bar sizes.")
end


 ------------------------------------------------------
 -------------------------Options Frames--------------
 ------------------------------------------------------
 
 -- Adds options to Blizzards addons options
 ShadsOpts = {}
 ShadsOpts.panel = CreateFrame("Frame", "MyAddonPanel", UIParent);
 ShadsOpts.panel.name = "ShadowmageUI Core";
 InterfaceOptions_AddCategory(ShadsOpts.panel);
 
 -- Title in options panel
 local optframe = ShadsOpts.panel:CreateFontString()
 makeFont(optframe, "TOP", 0, 0, 500, 100, 40, "|cff5CBBFf ShadowmageUI Config |r")
 
 -- Author (thats me!)
 local optauthor = ShadsOpts.panel:CreateFontString()
 makeFont(optauthor, "TOP", 0, -250, 500, 50, 12, "Created by Shadowmage - Stormrage EU")

 -- Text for editboxes
 local optfont1 = ShadsOpts.panel:CreateFontString()
 makeFont(optfont1, "LEFT", -100, 150, 300, 100, 12, "Top Bartender Bar Width:")
 optfont1:SetJustifyH("RIGHT")
 
 local optfont2 = ShadsOpts.panel:CreateFontString()
 makeFont(optfont2, "LEFT", -100, 100, 300, 100, 12, "Bottom Bartender Bar Width:")
 optfont2:SetJustifyH("RIGHT")
 
 -- Default button
 local defaultbutton = CreateFrame("Button", nil, ShadsOpts.panel)
 makeFrame(defaultbutton, "CENTER", 0, 50, {
	bgFile = "Interface\\BUTTONS\\UI-Panel-Button-Up.png",
	tiled = false,
}, 200, 40, 0.3, 0.3, 0.3, "HIGH")
 defaultbutton:SetHighlightTexture("Interface\\BUTTONS\\UI-Panel-Button-Highlight.png")
 defaultbutton:SetPushedTexture("Interface\\BUTTONS\\UI-Panel-Button-Down.png")
 defaultbutton:SetScript("OnClick", function() shads_default() end)
 
 local defaultfont = defaultbutton:CreateFontString()
 makeFont(defaultfont, "CENTER", -40, 7, 60, 50, 12, "Default")
 
 --------------------------------------
 -- minimap texture
local mmb = CreateFrame("Frame", nil, UIParent)
makeFrame(mmb, "TOPRIGHT", -14, -13, backdrop, 150, 150, .2, .2, .2, "LOW")	

-- speaks for itself
local layoutswitch = CreateFrame("button", nil, mmb)
makeFrame(layoutswitch, "BOTTOM", 0 , -195, backdrop, 148, 170, .2, .2, .2, "HIGH")
layoutswitch:Hide()
local LSText = layoutswitch:CreateFontString()
makeFont(LSText, "TOP", 0, 30, 140, 100, 16, "Select Layout")
-- switch frame under minimap
local switchframe = CreateFrame("button", nil, mmb)
makeFrame(switchframe, "BOTTOM", 38, -24, backdrop, 75, 22, .2, .2, .2, "MEDIUM")
	switchframe:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
	switchframe:GetHighlightTexture() :SetVertexColor(0, .7, .7);
	switchframe:SetScript("OnClick", function(self, button, down)
		if layoutswitch:IsVisible() then layoutswitch:Hide() else layoutswitch:Show() end
		--print("YAY I WAS CLICKED")
		end)

-- icon on switch frame button, changes from dps to healer if VuhDo is loaded		
local roleicon = CreateFrame("frame", nil, switchframe)
roleicon:SetPoint("CENTER")
roleicon:SetWidth(16)
roleicon:SetHeight(16)
roleicon:SetFrameStrata("HIGH")
roleicon:CreateTexture("roleicontex")
roleicontex:SetAllPoints()
roleicontex:SetTexture("Interface\\LFGFRAME\\LFGROLE.blp")
 
 -- Function to save the values in the edit box
 local function editboxsave(name, value)
	if tonumber(value) == nil then
		return print("|cff5CBBFF ShadowmageUI|r ERROR: Only numbers can be entered in this field!")
	end
	if name.id == 1 then
		print("|cff5CBBFF ShadowmageUI|r Setting top Bartender bar width too: " ..value)
		btwidth = tonumber(value)
	elseif name.id == 2 then
		print("|cff5CBBFF ShadowmageUI|r Settings bottom Bartender bar width too: " ..value)
		bbwidth = tonumber(value)	
	end
refreshbars()
shads_savevars()
end
 
 -- Function to make Edit boxes
 local function createEditBox(name, point, x, y, value)
	name:SetAutoFocus(false)
	name:SetMultiLine(false)
	name:SetWidth(80)
	name:SetHeight(18)
	name:SetMaxLetters(4)
	name:SetTextInsets(3, 0, 0, 0)
	name:SetBackdrop({
		bgFile = "Interface\\Buttons\\WHITE8x8",
		tiled = false,
	})
	name:SetBackdropColor(0, 0, 0, 1)
	name:SetBackdropBorderColor(0, 0, 0, 1)
	name:SetPoint(point, x, y)
	name:SetText(value)
	name:SetFontObject(GameFontHighlight)
	name:SetCursorPosition(0)
	name:SetScript("OnEscapePressed", function(self) self:ClearFocus() self:SetText(value) end)
	name:SetScript("OnEnterPressed", function(self) self:ClearFocus() editboxsave(name, self:GetText())  end)
	name:SetScript("OnEnter", function()
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR", 0, -16);
		GameTooltip:ClearAllPoints()
		GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
		GameTooltip:ClearLines()
		GameTooltip:AddLine("Press Enter to Save")
		GameTooltip:Show()
	end)
	name:SetScript("OnLeave", function()
		GameTooltip:Hide()
	end)
end

-- Creating the frames that the Editboxes will use and give them a unique ID
local opt1 = CreateFrame("EditBox", "opt1", ShadsOpts.panel)
opt1.id = 1
local opt2 = CreateFrame("EditBox", "opt2", ShadsOpts.panel)
opt2.id = 2
 
 -- Frame that handles addon loaded event to load saved variables
 local frame = CreateFrame("Frame");
 frame:RegisterEvent("ADDON_LOADED")
 
 local function eventHandler(self, event, ...)
	if event == "ADDON_LOADED" then
		local shadsname = ...;
		 if shadsname == "ShadsCore" then
			if shadsvar then
				bbwidth = shadsvar["bbwidth"]
				btwidth = shadsvar["btwidth"]
				healerui = shadsvar["healerui"]
				
			end
		-- Make things inside the event handler so stuff is created with the values of the saved variables
		createEditBox(opt1, "LEFT", 210, 150, btwidth)
		createEditBox(opt2, "LEFT", 210, 100, bbwidth)
		spawnframes()
		
		-- If healerui variable is true, set icon to healer icon, else dps icon
			if (healerui) then
			roleicontex:SetTexCoord(0.75, 1, 0, 1) -- 0.75, 1, 0, 1
				else
			roleicontex:SetTexCoord(0.25, 0.5, 0, 1)
			end
		end
	end
end
 
 frame:SetScript("OnEvent", eventHandler);
 
-- base left texture
local base = CreateFrame("frame", nil, UIParent)
makeFrame(base, "BOTTOMLEFT", -52, -15,{
		bgFile = "Interface\\AddOns\\ShadsCore\\Media\\Textures\\Base.tga"
		}, 1024, 512,  .2, .2, .2, "BACKGROUND")
base:SetFrameLevel(1)

--	base right texture
local base2 = CreateFrame("frame", nil, UIParent)
makeFrame(base2, "BOTTOMRIGHT", 52, -15, {
		bgFile = "Interface\\AddOns\\ShadsCore\\Media\\Textures\\Base2.tga"
		}, 1024, 512, .2, .2, .2, "BACKGROUND")
base2:SetFrameLevel(1)
-- top line texture		
local top = CreateFrame("frame", nil, UIParent)
makeFrame(top, "TOPLEFT", 0, 0, {
		bgFile = "Interface\\AddOns\\ShadsCore\\Media\\Textures\\Top.tga"
		}, 2048, 64, .2, .2, .2, "BACKGROUND")

-- extra line container
local extralinecont = CreateFrame("frame", nil, UIParent)
extralinecont:SetPoint("TOPRIGHT", 0, 0)
extralinecont:SetWidth(2048) --2048
extralinecont:SetHeight(64)
extralinecont:SetFrameStrata("BACKGROUND")
extralinecont:CreateTexture("extraline")	
extraline:SetAllPoints()
extraline:SetTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\Top.tga")
extraline:SetVertexColor(.2, .2, .2, 1)

local extralinecont2 = CreateFrame("frame", nil, UIParent)
extralinecont2:SetPoint("BOTTOM", 0,-23)
extralinecont2:SetWidth(1600) --2048
extralinecont2:SetHeight(64)
extralinecont2:SetFrameStrata("BACKGROUND")
extralinecont2:CreateTexture("extraline2")	
extraline2:SetAllPoints()
extraline2:SetTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\Top.tga")
extraline2:SetVertexColor(.2, .2, .2, 1)
	
-- bottom left stat texture
local bar3 = CreateFrame("frame", nil, base)
makeFrame(bar3, "BOTTOMLEFT", 125,23, backdrop, 265, 22, .2, .2, .2, "BACKGROUND") ---258, 23
bar3:SetFrameLevel(2)

-- top left stat texture
local bar4 = CreateFrame("frame", nil, UIParent)
makeFrame(bar4, "TOPLEFT", 34, -13, backdrop, 457, 22, .2, .2, .2, "LOW")

-- DPS button
local button1 = CreateFrame("button", nil, layoutswitch)
makeFrame(button1, "CENTER", 0, 25, backdrop, 130, 30, .5, .5, .5, "HIGH")
	button1:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
	button1:GetHighlightTexture() :SetVertexColor(0, .7, .7);
	button1:SetScript("OnClick", function(self, button, down)
	--	DisableAddOn("Grid2")
		healerui = false
		shads_savevars()		
		SlashCmdList["REFLUX"]("switch ShadsUIv6.6")

		--print("BUTTON 1")
		end)
local b1t = button1:CreateFontString()
makeFont(b1t, "CENTER", 0, 0, 130, 30, 12, "DPS Layout")
	
-- Healing button
local button2 = CreateFrame("button", nil, layoutswitch)
makeFrame(button2, "CENTER", 0, -10, backdrop, 130, 30, .5, .5, .5, "HIGH")
button2:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
	button2:SetScript("OnClick", function(self, button, down)
	--EnableAddOn("Grid2")
		healerui = true
		shads_savevars()		
		SlashCmdList["REFLUX"]("switch ShadsUIvHeals")
		--print("BUTTON 2")
		end)
local name, _, _, enabled, _, _, _ = GetAddOnInfo("Grid2")
	button2:SetScript("OnEnter", function()
		GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR", 0, -6);
		GameTooltip:ClearAllPoints()
		GameTooltip:SetPoint("BOTTOM", self, "TOP", 0, 1)
		GameTooltip:ClearLines()
		if name == "Grid2" then
			button2:GetHighlightTexture() :SetVertexColor(0, 0.7, 0);
		else
			GameTooltip:AddLine("Grid2 is NOT installed")
			button2:GetHighlightTexture() :SetVertexColor(1, 0, 0);
		end
		GameTooltip:Show()
		end)
	button2:SetScript("OnLeave", function() GameTooltip:Hide() end)		
local b2t = button2:CreateFontString()
makeFont(b2t, "CENTER", 0, 0, 130, 30, 12, "Healing Layout")

-- Close button
local button3 = CreateFrame("button", nil, layoutswitch)
makeFrame(button3, "CENTER", 0, -45, backdrop, 130, 30, .5, .5, .5, "HIGH")
	button3:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
	button3:GetHighlightTexture() :SetVertexColor(0, .7, .7);
	button3:SetScript("OnClick", function(self, button, down)
		layoutswitch:Hide()
		--print("BUTTON 3")
		end)
local b3t = button3:CreateFontString()
makeFont(b3t, "CENTER", 0, 0, 130, 30, 12, "Close Window")

-- main raid util frame 
local raidutilities = CreateFrame("frame", nil, mmb)
makeFrame(raidutilities, "BOTTOM", -176, -195, backdrop, 200, 193, .2, .2, .2, "MEDIUM")
raidutilities:Hide()

-- frame if player not in raid, ask to convert
local noraidopt = CreateFrame("frame", nil, mmb)	
makeFrame(noraidopt, "BOTTOM", -176, -195, backdrop, 200, 193, .2, .2, .2, "MEDIUM")
noraidopt:Hide()
local noraidopttext = noraidopt:CreateFontString()
makeFont(noraidopttext, "CENTER", 0, 20, 180, 190, 14, "You must be in a raid group to use these options, would you like to convert party?")

-- Convert to raid button	
local convertbutton = CreateFrame("button", nil, noraidopt)
makeFrame(convertbutton, "BOTTOM", 0, 45, backdrop, 168, 30, .7, .7, .7, "HIGH")	
local convertfont = convertbutton:CreateFontString()
makeFont(convertfont, "CENTER", 0, 0, 160, 30, 12, "Convert to Raid")
convertbutton:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
convertbutton:GetHighlightTexture() :SetVertexColor(0, .7, .7);
convertbutton:SetScript("OnClick", function(self, button, down)
ConvertToRaid()
noraidopt:Hide()
end)
	
-- button to close no raid frame
local closenoraid = CreateFrame("button", nil, noraidopt)
makeFrame(closenoraid, "BOTTOM", 0, 7, backdrop, 168, 30, .7, .7, .7, "HIGH")
closenoraid:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
closenoraid:GetHighlightTexture() :SetVertexColor(0, .7, .7);
local closenoraidtxt = closenoraid:CreateFontString()
makeFont(closenoraidtxt, "CENTER", 0, 0, 168, 30, 12, "Close Window")
closenoraid:SetScript("OnClick", function(self, button, down)
noraidopt:Hide()
end)

-- Raid options button
local raidopt = CreateFrame("button", nil, mmb)
makeFrame(raidopt, "BOTTOM", -37, -24, backdrop, 75, 22, .2, .2, .2, "HIGH")
raidopt:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
raidopt:GetHighlightTexture() :SetVertexColor(0, .7, .7);
raidopt:SetScript("OnClick", function(self, button, down)
if UnitInRaid("player") == nil then
	if noraidopt:IsVisible()	then noraidopt:Hide() else noraidopt:Show() end 
else
	if raidutilities:IsVisible()	then raidutilities:Hide() else raidutilities:Show() end
end	-- add check for if in raid = true
	end)
local raidopticon = CreateFrame("frame", nil, raidopt)
makeFrame(raidopticon, "CENTER", 0, 0, {bgFile = "Interface\\GROUPFRAME\\UI-GROUP-LeaderIcon"}, 20, 20, 1, 1, 1, "HIGH")

-- flag frames and function
local flagframe = CreateFrame("button", nil, raidutilities)
flagframe:SetPoint("TOPLEFT", 17, -12)
flagframe:SetWidth(200)
flagframe:SetHeight(200)
flagframe:SetFrameLevel(6)

	for i = 1, 6 do
		flagframe[i] = CreateFrame("button", "flag"..i, flagframe, "SecureActionButtonTemplate")
		flagframe[i]:SetHeight(50)
		flagframe[i]:SetWidth(50)
		flagframe[i]:SetBackdrop(backdrop)
		flagframe[i]:SetBackdropColor(.2, .2, .2, 1)

			if i==1 then
				flagframe[i]:SetPoint("TOPLEFT", flagframe)
			else if i == 4 then
				flagframe[i]:SetPoint("LEFT", flagframe[1], "LEFT", 0, -60)
			else
				flagframe[i]:SetPoint("LEFT", flagframe[i-1], "RIGHT", 8, 0)
			end
	end

flagframe[i]:SetAttribute("type1", "macro");

	if i == 6 then
		flagframe[i]:SetAttribute("macrotext1", "/cwm 0");	
	else
		flagframe[i]:SetAttribute("macrotext1", "/wm "..i);
	end

end

-- All the flag textures
flagframe[1]:CreateTexture("bluemark")
bluemark:SetHeight(40)
bluemark:SetWidth(40)
bluemark:SetPoint("CENTER")
bluemark:SetTexture("Interface\\TARGETINGFRAME\\UI-RaidTargetingIcon_6")

flagframe[2]:CreateTexture("greenmark")
greenmark:SetHeight(40)
greenmark:SetWidth(40)
greenmark:SetPoint("CENTER")
greenmark:SetTexture("Interface\\TARGETINGFRAME\\UI-RaidTargetingIcon_4")

flagframe[3]:CreateTexture("purplemark")
purplemark:SetHeight(40)
purplemark:SetWidth(40)
purplemark:SetPoint("CENTER")
purplemark:SetTexture("Interface\\TARGETINGFRAME\\UI-RaidTargetingIcon_3")
 
flagframe[4]:CreateTexture("redmark")
redmark:SetHeight(40)
redmark:SetWidth(40)
redmark:SetPoint("CENTER")
redmark:SetTexture("Interface\\TARGETINGFRAME\\UI-RaidTargetingIcon_7")
 
flagframe[5]:CreateTexture("yellowmark")
yellowmark:SetHeight(40)
yellowmark:SetWidth(40)
yellowmark:SetPoint("CENTER")
yellowmark:SetTexture("Interface\\TARGETINGFRAME\\UI-RaidTargetingIcon_1")

flagframe[6]:CreateTexture("removemark")
removemark:SetHeight(40)
removemark:SetWidth(40)
removemark:SetPoint("CENTER")
removemark:SetTexture("Interface\\SpellShadow\\Spell-Shadow-Unacceptable")

-- Role Poll button
local rolecheck = CreateFrame("button", nil, raidutilities)
makeFrame(rolecheck, "CENTER", -42, -44, backdrop, 81, 30, .7, .7, .7, "HIGH")
rolecheck:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
rolecheck:GetHighlightTexture() :SetVertexColor(0, .7, .7);
local rctxt = rolecheck:CreateFontString()
makeFont(rctxt, "CENTER", 0, 0, 81, 30, 12, "Role?")
rolecheck:SetScript("OnClick", function(self, button, down)
InitiateRolePoll();
print("|cff5CBBFF ShadowmageUI|r: Role check initiated. |cffff8040 Note: You may not see anything if a separate addon handles the role poll (e.g. BigWigs, DBM)")
end)

-- Ready Check button
local readycheck = CreateFrame("button", nil, raidutilities)
makeFrame(readycheck, "CENTER", 42, -44, backdrop, 81, 30, .7, .7, .7, "HIGH")
readycheck:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
readycheck:GetHighlightTexture() :SetVertexColor(0, .7, .7);
local rtxt = readycheck:CreateFontString()
makeFont(rtxt, "CENTER", 0, 0, 81, 30, 12, "Ready?")
readycheck:SetScript("OnClick", function(self, button, down)
DoReadyCheck()
print("|cff5CBBFF ShadowmageUI|r: Ready check initiated.")
end)

-- Close raid utilities frame
local closeraidu = CreateFrame("button", nil, raidutilities)
makeFrame(closeraidu, "BOTTOM", 0, 7, backdrop, 168, 30, .7, .7, .7, "HIGH")
closeraidu:SetHighlightTexture("Interface\\AddOns\\ShadsCore\\Media\\Textures\\fer2.tga")
closeraidu:GetHighlightTexture() :SetVertexColor(0, .7, .7);
local closetxt = closeraidu:CreateFontString()
makeFont(closetxt, "CENTER", 0, 0, 168, 30, 12, "Close Window")
closeraidu:SetScript("OnClick", function(self, button, down)
raidutilities:Hide()
end)

-- Slash command
SLASH_SHADSUI1 = "/shads";
function SlashCmdList.SHADSUI(msg)
	InterfaceOptionsFrame_OpenToCategory(ShadsOpts.panel);
	InterfaceOptionsFrame_OpenToCategory(ShadsOpts.panel); -- twice to avoid blizz bug
end

SetCVar("profanityFilter", 0)